
<template>
    <el-container style="height: 100%">
        <el-header>
            <commonheader></commonheader>
        </el-header>
        <el-container>
            <el-aside width="auto">
                <commonaside></commonaside>
            </el-aside>
            <el-main>
              <div class="tabControl">
                <div >
                  <el-row class="foodrow" type="flex" justify="center" >
                    <el-col :lg="12" :md="15" :sm="18" :xs="24" class="foodcol">
                      <el-card class="el-card">
                        <el-row :gutter="60" class="foodrow" type="flex" >
                          <el-col :lg="10" :xs="24" class="foodcol">
                            <img :src="shopInfo.shopImage" class="image">
                          </el-col>
                          <el-col :lg="14" :xs="24" class="foodcol">
                            <span style="text-align: center;display:block; font-size: 1.6em;">{{shopInfo.shopName}}<br></span>
                            <span style="display:block; font-size: 1.2em; width:auto;">{{'商店介绍：'+shopInfo.shopIntroduction}}</span>
                            <span style="display:block; font-size: 1.2em; width:auto;">{{'商店类型：'+shopInfo.shopType}}</span>
                            <span style="display:block; font-size: 1.2em; width:auto;">{{'商店地址：'+shopInfo.shopLocation}}</span>
                            <div style="width: 100%; text-align:right;"  v-if="islogin">
                              <el-button type="primary" size="mini" @click="goComment()">查看评论</el-button>
                            </div>
                          </el-col>
                        </el-row>
                      </el-card>
                    </el-col>
                  </el-row>
                  <el-row  :gutter="20"  class="foodrow" type="flex">
                    <el-col :lg="6" :xs="24"  v-for="(item,index) in goodsList" id=item :key="item.foodID" class="foodcol">
                      <el-card class="el-card"  :key="index"  onclick="" v-if="(index >=(page.currentPage-1)*page.pageSize) && (index <(page.currentPage)*page.pageSize)" :shadow = "item.foodTakeStatus == 0 ? 'never' : 'always'" :style= "item.foodTakeStatus == 0 ? 'background-color: #f0f0f0;' : 'background-color: white' ">
                        <img :src="item.foodImage" class="image">
                        <div style="padding: 14px;">
                          <span style="text-align: center;display:block; font-size: 1em;">{{item.foodTakeStatus != 0? item.foodName : item.foodName+'[已下架]'}}<br></span>
                          <span style="display:block; font-size: 0.8em; width:auto;">{{'食品类型：'+item.foodCategory}}</span>
                          <span style="display:block; font-size: 0.8em; width:auto; ">{{'食品热量：'+item.foodCalorie+'cal'}}</span>
                          <span style="display:inline-block; width: auto; font-size: 1em; color: red;">{{'￥'+item.foodPrice}}</span>
                          <span style="display:inline-block; width: auto; font-size: 0.5em; color: grey;">{{'余量'+item.foodNumber}}</span>
                          <div style="display: block; width: 100%;">
                               <el-popover
                              placement="top-start"
                              v-for="idlable in item.ingredientList"
                              id=idlable :key="idlable.ingredientId"
                              width="auto"
                              trigger="hover">
                                <div style="padding: 14px;">
                                  <span style="text-align: center;display:block; font-size: 1em;">{{idlable.ingredientName}}<br></span>
                                  <span style="display:block; font-size: 0.8em; width:auto;">{{'食材类型：'+idlable.ingredientCategory}}</span>
                                  <span style="display:block; font-size: 0.8em; width:auto; ">{{'食材热量：'+idlable.ingredientCalorie+'cal'}}</span>
                                </div>
                              <el-button type="info" :disabled="item.foodTakeStatus == 0" plain round style="display: inline-block; width: auto; padding: 7.5px; margin-right: 3px;" slot="reference">hover</el-button>
                            </el-popover>
                            <div class="bottom clearfix" >
                              <div style="width: 100%; text-align:right;"  v-if="islogin">
                                <el-input-number size="mini" v-model="nums[item.foodId]" :min="0" :max="100" @change="numberChange"></el-input-number>
                                <el-button type="primary" size="mini" @click="directBuy(item.foodId)" :disabled="disable" >直接购买</el-button>
                              </div>
                            </div>
                          </div>
                        </div>
                      </el-card>
                    </el-col>
                  </el-row>
                </div>
                <div style="width: 100%; text-align:center; position:sticky; bottom:0;"  v-if="islogin">
                  <el-button type="success" round @click="settlement()" :disabled="disable">结算</el-button>
                  <el-button type="danger" round @click="reset()">重置</el-button>
                </div>
                <div style="width: 100%; text-align:center; position:sticky; bottom:0;"  v-if="islogin">
                  <span style="font-size: 0.75em; color: red;">{{money}}</span>
                </div>
                <span style="height: 5em;"></span>
                <div id="pager" class="pager01">
                  <el-pagination
                  @current-change="CurrentChange"
                  background layout="total,  prev, pager, next, jumper"
                  :total="goodsList.length"
                  :page-size="4"
                  :current-page.sync="page.currentPage"
                  >
                  </el-pagination>
                </div>
              </div>
            </el-main>
        </el-container>
    </el-container>
</template>

<script>
import BrowseFoodByShopID from '@/services/BrowseFoodByShopID'
import showViewInfoService from '@/services/showViewInfoService'
import commonaside from '../components/commonaside.vue'
import commonheader from '../components/commonheader.vue'
export default {
  components: {
    commonaside,
    commonheader
  },

  name: 'BrowseFoodByShopID',
  data () {
    return {
      page: {
        pageSize: 4,
        currentPage: 1,
        total: 0
      },
      shopInfo: {
      },
      goodsList: [],
      islogin: 0,
      userInfo: {
        userId: '1',
        userIsFoodMerchant: 5
      },
      nums: {
      },
      price: {
      },
      calorie: {
      },
      money: '总金额:0元 总热量:0卡',
      disable: false
    }
  },
  created () {
    this.islogin = this.$store.state.token !== ''
    this.getShopGoodsList()
    this.getUserInfo()
  },
  methods: {
    // 获取商品列表
    async getShopGoodsList () {
      try {
        const response = await BrowseFoodByShopID.getShopGoodList(this.$route.params.id, {
          headers: {'Authorization': this.$store.state.token}
        })
        this.goodsList = response.data.data.shopFood.foodList
        this.shopInfo = response.data.data.shopFood
        console.log(this.goodsList)
        for (var i = 0; i < this.goodsList.length; i++) {
          console.log('ID:' + this.goodsList[i].foodId)
          this.nums[this.goodsList[i].foodId] = 0
          console.log(this.goodsList[i].foodPrice)
          this.price[this.goodsList[i].foodId] = this.goodsList[i].foodPrice
          this.calorie[this.goodsList[i].foodId] = this.goodsList[i].foodCalorie
        }
        console.log(this.$route.query.isRec)
        if (this.$route.query.isRec !== undefined && this.$route.query.isRec !== 0) {
          console.log('LLOG')
          var recommendList = JSON.parse(sessionStorage.getItem('recommend'))
          console.log(recommendList)
          if (recommendList !== '' && recommendList !== {}) {
            for (var r in recommendList) {
              this.nums[r] = recommendList[r]
            }
          }
          this.numberChange()
          var RecNum = 0
          for (var n = 0; n < this.goodsList.length; n++) {
            if (this.nums[this.goodsList[n].foodId] !== undefined && this.nums[this.goodsList[n].foodId] !== 0) {
              RecNum++
            }
          }
          // eslint-disable-next-line eqeqeq
          if (RecNum == this.$route.query.isRec) {
            this.$message({
              type: 'success',
              message: '成功设置了推荐菜单'
            })
          } else {
            this.$message({
              type: 'warning',
              message: '抱歉,您推荐的商品部分已经下架'
            })
          }
        }
      } catch (error) {
        this.$message({
          type: 'error',
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,不可达' : error.response.data.msg
        })
        this.$router.go(-1)
      }
    },
    async getUserInfo () {
      if (!this.islogin) {
        return
      }
      try {
        const response = await showViewInfoService.getInfo({
          headers: {'Authorization': this.$store.state.token}
        })
        this.userInfo = response.data.data.user
      } catch (error) {
        this.$message({
          type: 'error',
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,不可达' : error.response.data.msg
        })
        this.$router.go(-1)
      }
    },
    async postFoodOrder (foods, addr) {
      if (!this.islogin) {
        this.$message({
          type: 'error',
          message: '尚未登陆无法结算'
        })
        return
      }
      if (foods.length === 0) {
        return
      }
      this.disable = true
      try {
        const response = await BrowseFoodByShopID.Order({
          userId: this.userInfo.userId,
          shopId: this.$route.params.id,
          foodIdAndNum: foods,
          foodOrderLocation: addr
        }, {
          headers: {'Authorization': this.$store.state.token}
        })
        if (response.data.code !== 200) {
          this.$message({
            type: 'error',
            message: response.data.msg
          })
        }
        this.$message({
          type: 'success',
          message: response.data.msg
        })
        for (var i in this.nums) {
          this.nums[i] = 0
        }
        this.numberChange()
      } catch (error) {
        this.$message({
          type: 'error',
          message: error.response === undefined || typeof error.response.data === 'undefined' ? '网络错误,不可达' : error.response.data.msg
        })
      }
      this.disable = false
    },
    pages () {
      const pages = []
      this.goodsList.forEach((item, index) => {
        const page = Math.floor(index / 2)
        if (!pages[page]) {
          pages[page] = []
        }
        pages[page].push(item)
      })
      return pages
    },
    handleCurrentChange (val) {
      var thispage = this
      thispage.currentpage = val
      thispage.initPage()
    },
    CurrentChange (currentPage) {
      this.page.currentPage = currentPage
    },
    settlement () {
      var foods = []
      for (var i in this.nums) {
        if (this.nums[i] !== undefined && this.nums[i] !== 0) {
          foods.push(this.nums[i])
        }
      }
      if (foods.length === 0) {
        return
      }
      this.$prompt('请输入收件地址', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消'
      }).then(({ value }) => {
        var foods = []
        for (var i in this.nums) {
          var twins = []
          if (this.nums[i] !== undefined && this.nums[i] !== 0) {
            twins.push(i)
            twins.push(this.nums[i])
            foods.push(twins)
          }
        }
        this.postFoodOrder(foods, value)
        this.numberChange()
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消购买'
        })
      })
    },
    directBuy (index) {
      if (this.nums[index] === 0) {
        return
      }
      this.$prompt('请输入收件地址', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消'
      }).then(({ value }) => {
        var foods = []
        var twins = []
        if (this.nums[index] !== undefined && this.nums[index] !== 0) {
          twins.push(index)
          twins.push(this.nums[index])
          foods.push(twins)
        }
        this.postFoodOrder(foods, value)
        this.numberChange()
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消购买'
        })
      })
    },
    reset () {
      var foods = []
      for (var i in this.nums) {
        if (this.nums[i] !== undefined && this.nums[i] !== 0) {
          foods.push(this.nums[i])
        }
      }
      if (foods.length === 0) {
        return
      }
      this.$confirm('您确定重置所有购物信息吗?', '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        for (var i in this.nums) {
          this.nums[i] = 0
        }
        this.numberChange()
        this.$message({
          type: 'success',
          message: '已成功重置'
        })
      }).catch(() => {
        this.$message({
          type: 'info',
          message: '已取消重置'
        })
      })
    },
    numberChange () {
      var tolMoney = 0
      var tolCalorie = 0
      for (var i in this.goodsList) {
        if (this.nums[this.goodsList[i].foodId] !== undefined && this.nums[this.goodsList[i].foodId] !== 0) {
          tolMoney = tolMoney + this.nums[this.goodsList[i].foodId] * this.price[this.goodsList[i].foodId]
          tolCalorie = tolCalorie + this.nums[this.goodsList[i].foodId] * this.calorie[this.goodsList[i].foodId]
        }
      }
      this.money = '总金额:' + tolMoney.toFixed(1) + '元 总热量:' + tolCalorie.toFixed(1) + '卡'
      this.$forceUpdate()
    },
    goComment () {
      this.$router.push('/foodshops/' + this.$route.params.id + '/comments')
    }
  }
}

</script>

<style>
  .time {
  font-size: 13px;
  color: #999;
  }
  .bottom {
  margin-top: 13px;
  line-height: 12px;
  }
  .clearfix:before,
  .clearfix:after {
      display: table;
      content: "";
  }
  .clearfix:after {
      clear: both
  }
  .image {
  width: 100%;
  display: block;
  }
  .foodrow {
  margin-bottom: 20px;
  display: flex;
  flex-wrap: wrap
  }
  .foodrow .foodcol {
  border-radius: 4px;
  align-items: stretch;
  margin-bottom: 0px;
  margin-top: 20px;
  }
  .el-card{
    height: 100%;
    min-width: 100%;
    transition: all .5s;
  }
  .el-header {
  background-color: #333;
  }
  .el-main {
    padding-top: 0;
  }
  .pager01{
    left:0;
    bottom: 0;
    width:100%;
    height:50px;
    text-align: center;
    list-style: none;
    padding-top:8px;
  }
</style>
